#include <RFduinoBLE.h>

/* 주석 – 보통은 프로젝트 설명 
초음파 센서로 거리를 측정해서, 10 세그먼트에 표시하기 
Copyright (c) 2017 Blueinno.cc  All right reserved.
*/

#define   MIDBUFF_SIZE   5
#define   MAX_DISTANCE   300  // Max Distance is 3 m
#define   MODE_DETECT_COUNT  10
#define   MODE1          0
#define   MODE2          1
#define   MODE3          2
#define   MODE4          3

// 환경 설정 
// Pin for Ultrasound sensor
int trigPin = 1;  // trigPin을 1번에 설정
int echoPin = 2; // echoPin을 2번에 설정 

// Pin for Ten SEG
int led0 = 3;  // led0을 3번 핀에 설정
int led1 = 4;  // led1을 4번 핀에 설정
int led2 = 5;  // led2을 5번 핀에 설정
int led3 = 6;  // led3을 6번 핀에 설정
int led4 = 7;  // led4을 7번 핀에 설정
int led5 = 8;  // led5을 8번 핀에 설정
int led6 = 9;  // led6을 9번 핀에 설정
int led7 = 10; // led7을 10번 핀에 설정
int led8 = 11; // led8을 11번 핀에 설정
int led9 = 12; // led9을 12번 핀에 설정

int iC = 0;
int iCCC = 0;
int gMode = MODE1;
int gNoObjectCount = 0;
int D_Unit[10];

// 피보나치 수열을 이용해 LED 당 거리 계산
void MakeDUnit()
{
  int i;
  
  //???? D_Unit[0] 수정하면 
  D_Unit[0] = 10;
  
  for(i=1;i<10;i++)
  {
    if (i == 1)
      D_Unit[i] = D_Unit[0];
    else
      D_Unit[i] = D_Unit[i-1] + D_Unit[i-2];  
  }
}

// 한번 실행할 코드를 설정 
void setup(){
  // UART Setting
  Serial.begin(9600);  // 시리얼 시작과 속도 9600pbs 설정 

  // Ultrasound Pin Setting
  pinMode(trigPin, OUTPUT); // trigPin을 출력을 설정 
  pinMode(echoPin, INPUT); // echoPin을 입력으로 설정 
  
  // Ten Seg Pin Setting
  pinMode(led0, OUTPUT); // led0을 출력핀으로 설정 
  pinMode(led1, OUTPUT); // led1을 출력핀으로 설정
  pinMode(led2, OUTPUT); // led2을 출력핀으로 설정
  pinMode(led3, OUTPUT); // led3을 출력핀으로 설정
  pinMode(led4, OUTPUT); // led4을 출력핀으로 설정
  pinMode(led5, OUTPUT); // led5을 출력핀으로 설정
  pinMode(led6, OUTPUT); // led6을 출력핀으로 설정
  pinMode(led7, OUTPUT); // led7을 출력핀으로 설정
  pinMode(led8, OUTPUT); // led8을 출력핀으로 설정
  pinMode(led9, OUTPUT); // led9을 출력핀으로 설정

  MakeDUnit();

    RFduinoBLE.advertisementData = "ultra";
    // start the BLE stack
    RFduinoBLE.advertisementInterval = 200;
    RFduinoBLE.begin();    
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

boolean ble_bConnected = false;
void RFduinoBLE_onConnect(void) {
  
  Serial.println("RFduinoBLE_onConnect...");

  //RFduinoBLE.updateConnInterval(900, 1100);
  RFduinoBLE.updateConnInterval(100, 200);
 
  ble_bConnected = true;
//  delay(1000);
}
 
void RFduinoBLE_onDisconnect(void) {
  Serial.println("RFduinoBLE_onDisconnect...");
 
  ble_bConnected = false;
}
 
void RFduinoBLE_onReceive(char * data, int len) {
  char temp[128] = { 0x00, };
 
  strcpy(temp, "RECV:\t");
  strncpy(temp+5, data, len);
  Serial.println(temp);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

// 받은 거리값을 10 세그먼트로 표시하는 알고리즘 함수입니다. 
void DistanceTenSeg(float distance)
{
  int a = distance;  // 거리 값을 10으로 나누어 10Cm 단위로 나눔
  int b = led0;
  int i;
  int p;
  
  // LED 모두 끄기
  //for(i=0;i<=9;i++) 
  //  digitalWrite(i+b, LOW);   // 거리 값 보다 높은 LED를 끄고 

  if (gMode == MODE1)
  {
    a = (a + 5) / 10;
    
    for(i=0;i<a;i++)
      digitalWrite(i+b, HIGH);   // 거리 값에 보다 낮은 LED를 껴고 
  }
  else if (gMode == MODE2)
  {
    a = (a + 15) / 30;
    
    for(i=0;i<a;i++)
      digitalWrite(i+b, HIGH);   // 거리 값에 보다 낮은 LED를 껴고 
  }
  else if (gMode == MODE3)
  {
    for(i=0;i<10;i++)
    {
      p = pow(2,i);
      if (a & p)
      {
        digitalWrite(i+b, HIGH);   // 거리 값에 보다 낮은 LED를 껴고 
      }
      else {
        digitalWrite(i+b, LOW);   // 거리 값에 보다 낮은 LED를 껴고 <---------------------------
      }
    }  
  }
//  else 
//  { 
//    for(i=0;i<10;i++)
//    {
//      if (a > D_Unit[i])
//        digitalWrite(i+b, HIGH);   // 거리 값에 보다 낮은 LED를 껴고 
//      else
//        break;
//    }
//  }
}

void ModeTenSeg()
{
  int i;
  int b = led0;
  
  for(i=0;i<=9;i++) 
    digitalWrite(i+b, LOW);   // 거리 값 보다 높은 LED를 끄고 

  gMode = gMode + 1;
  
  if (gMode > MODE3)
    gMode = MODE1;

  if (gMode == MODE1)
    digitalWrite(led9, HIGH);
  else if (gMode == MODE2)
    digitalWrite(led8, HIGH);
  else if (gMode == MODE3)
    digitalWrite(led7, HIGH);
//  else
//    digitalWrite(led6, HIGH);
}

int DetectModeChange(float distance)
{
  if (distance == -1)
  {
    gNoObjectCount = gNoObjectCount + 1;
    
    if (gNoObjectCount > MODE_DETECT_COUNT)
    {
      gNoObjectCount = 0;
      return 1;
    }
  }
  else
  {
    gNoObjectCount = 0;
  }
  
  return 0;
}

int DetectNobody(float distance)
{
  if (distance == -1)
  {
    
    if (gNoObjectCount > 2)
    {
      return 1;
    }
  }
  
  return 0;
}

int timeout = 0;
char str[16];

// 반복 설정 
void loop() {
  
  int i;
  int ModeChange;
  float duration, distance; // duration, distance를 실수 변수로 설정

  /**********************************************************/
  /*********** Measure Distance *****************************/
  digitalWrite(trigPin, HIGH); // trigPin을 HIGH로 출력
  delay(10); // 10ms 대기 
  digitalWrite(trigPin, LOW); // trigPin을 LOW로 출력
   
  /* echoPin 이 HIGH를 유지한 시간을 저장한다.
  HIGH 였을 때 시간(초음파가 보냈다가 다시 들어온 시간)을 
  가지고 거리를 계산 한다.
  */
  // duration = pulseIn(echoPin, HIGH);
  duration = pulseIn(echoPin, HIGH, 5000);
  
  // 340은 초당 초음파(소리)의 속도, 10000은 밀리세컨드를 세컨드로, 
  // 왕복거리이므로 2로 나눠준다.
  distance = ((float)(340 * duration) / 10000) / 2;
  
  // 거리가 측정범위를 넘어서면 물체가 없다고 판단
  if (distance > MAX_DISTANCE)
  {
    distance = -1;  // 측정 범위내에 물체 없음
  }
  /**********************************************************/
  /**********************************************************/

  /**********************************************************/
  // Mode Change 감지
  // JoyTest 2018-02-09 ModeChange = DetectModeChange(distance);
  gMode = MODE3;
  
  /**********************************************************/
  /**********************************************************/

  /**********************************************************/
  // 10 Seg에 표시
  
  if (ModeChange == 1)
  {
    ModeTenSeg(); // Mode 표시  
  }
  else
  {
    if (distance != -1)
      DistanceTenSeg(distance);  
    else if (DetectNobody(distance))
      DistanceTenSeg(0);  
  }
  
  
  
  /**********************************************************/
  /**********************************************************/
   
  /**********************************************************/
  /**********************************************************/
  if (distance != -1) 
  // if(ble_bConnected == false)
  {
    // 외부 통신
    Serial.print("@2,1,1,");
    Serial.print(iCCC);
    Serial.print(",");
    Serial.print(distance);
    Serial.println("#");
  }
    
  iCCC = iCCC + 1;
  /**********************************************************/
  /**********************************************************/

  if (distance != -1)
  if(ble_bConnected == true) {
    
    sprintf(str, "%d.%02d", (int)distance, (int)(distance*100)%100);
    timeout += 1;
    RFduinoBLE.send(str, strlen(str));  

    
  }
    delay(100);
}


